{ Ager's Socket Library (c) Copyright 1998-99 by Soren Ager (sag@poboxes.com) }
{                                                                             }
{ $Revision: 1.4 $    $Date: 1999/07/15 07:55:55 $    $Author: sag $ }
{                                                                             }
{ Post Office Protocol - Version 3 (POP3) client example                      }
PROGRAM POP3Get;

{$I aslDefine.Inc}
{&PMType VIO}

USES Classes, SysUtils, aslGlobals, aslAbsSocket, aslPOP3Client;

TYPE
  TMyPOP3Client = CLASS(TPOP3Client)
    PROCEDURE DoLogLine(Msg: String);
  END;

CONST
  Server : STRING = '';
  User   : STRING = '';
  Pass   : STRING = '';
  Path   : STRING = '';
  Log    : STRING = '';
  UseLog : Boolean = False;
  Delete : Boolean = False;

  PROCEDURE TMyPOP3Client.DoLogLine(Msg: String);
  VAR
    Out : Text;
  BEGIN
    Assign(Out, Log);
    {$I-} Append(Out); {$I+}
    IF IOResult<>0 THEN Rewrite(Out);
    WriteLn(Out, Msg);
    Close(Out);
  END;


  PROCEDURE ShowCopyright;
  BEGIN
    WriteLn('POP3Get  Release '+aslRelease+'   '+aslCopyright);
    WriteLn(aslPartOf);
    WriteLn('Downloads e-mail from a POP3 server to text files.');
    WriteLn;
  END;

  PROCEDURE ShowHelp;
  BEGIN
    WriteLn('Usage:');
    WriteLn;
    WriteLn('  POP3Get /S<Server> /U<User> [/P<Password>] [/D<Dir>] [/L[<LogFile>]] [/R]');
    WriteLn;
    WriteLn('where:');
    WriteLn('  <Server>   is the name of the POP3 server.');
    WriteLn('  <User>     is the user name.');
    WriteLn('  <Password> is the password for <user> - if required.');
    WriteLn('  <Dir>      is the directory to place the messages in - current is default.');
    WriteLn('  <LogFile>  is the name of the file to log to, if /L is specified without a');
    WriteLn('             filename, loginfo will be written to the screen.');
    WriteLn('  /R         removes the message from the server after download.');
    WriteLn;
    WriteLn('examples:');
    WriteLn('  POP3Get /Smail /Uuser /Psecret /Dc:\mail /Lc:\mail\mail.log /R');
    WriteLn('  POP3Get /Smail /Uuser /Psecret /R');
    Halt(1);
  END;

  PROCEDURE GetParm;
  VAR
    i : Integer;
  BEGIN
    FOR i:=1 TO ParamCount DO
      IF Length(ParamStr(i))>1 THEN
      BEGIN
        CASE UpCase(ParamStr(i)[2]) OF
          'S' : Server:=Copy(ParamStr(i), 3, Length(ParamStr(i))-2);
          'U' : User:=Copy(ParamStr(i), 3, Length(ParamStr(i))-2);
          'P' : Pass:=Copy(ParamStr(i), 3, Length(ParamStr(i))-2);
          'D' : BEGIN
            Path:=Copy(ParamStr(i), 3, Length(ParamStr(i))-2);
            IF (Path<>'') AND (Copy(Path, Length(Path), 1)<>'\') THEN Path:=Path+'\';
          END;
          'L' : BEGIN
            Log:=Copy(ParamStr(i), 3, Length(ParamStr(i))-2);
            UseLog:=True;
          END;
          'R' : Delete:=True;
          ELSE
            ShowHelp;
        END;
      END ELSE
        ShowHelp;
  END;

  PROCEDURE GetTheMail;
  VAR
    i   : Integer;
    Cli : TMyPOP3CLient;
    Msg : TStringList;
  BEGIN
    TRY
      Cli:=TMyPOP3Client.Create;
      TRY
        IF UseLog THEN Cli.OnLogLine:=Cli.DoLogLine;
        Cli.LogLine('');
        Cli.DelAfter:=Delete;
        Cli.Connect(Server, User, Pass);
        WriteLn('You have ',Cli.Msgs,' messages, with a total size of ',Cli.Size,' bytes waiting');
        Msg:=TStringList.Create;
        FOR i:=1 TO Cli.Msgs DO
        BEGIN
          Write('Fetching: ',i,#13);
          Cli.GetMsg(i, Msg);
          Msg.SaveToFile(Path+'DL-'+IntToHex(i,5)+'.POP');
          Msg.Clear;
        END;
        Msg.Destroy;
        WriteLn;
      FINALLY
        Cli.Destroy;
      END;
    EXCEPT
      ON e: EaslException DO WriteLn('Error: ',e.Message);
      ELSE RAISE;
    END;
  END;

BEGIN
  ShowCopyright;
  IF ParamCount>0 THEN
  BEGIN
    GetParm;
    IF (Server<>'') AND (User<>'') THEN GetTheMail ELSE ShowHelp;
  END ELSE
    ShowHelp;
END.

